package org.maltparser.core.sentence;

import org.maltparser.core.dataformat.ColumnDescription;
import org.maltparser.core.exception.MaltChainedException;

/**

@author Johan Hall
@since 1.0
*/
public class IntegerColumnInstance extends ColumnInstance {
	private int value;
	public IntegerColumnInstance(ColumnDescription column) {
		super(column,true);
	}
		
	public void setValue(String v) throws MaltChainedException  {
		if (v.length() == 0) {
			value = 0;
			return;
		}
		try {
			value = Integer.parseInt(v);
		} catch (NumberFormatException e) {
			throw new SentenceException("The integer column attribute must be a non-negative integer value, not "+v+". ");
		}
		if (value < 0) {
			throw new SentenceException("The integer column attribute must be a non-negative integer value, not "+value+". ");
		}
	}
	
	public int getIntegerValue() {
		return value;
	}
	
	public String getStringValue() {
		return Integer.toString(value);
	}
}
