package org.maltparser.core.symbol;

import java.io.BufferedReader;
import java.io.BufferedWriter;

import org.apache.log4j.Logger;
import org.maltparser.core.exception.MaltChainedException;
import org.maltparser.core.symbol.nullvalue.NullValues.NullValueId;

public interface SymbolTable {
	public int addSymbol(String value) throws MaltChainedException;
	public String getSymbolCodeToString(Integer value) throws MaltChainedException;
	public int getSymbolStringToCode(String value) throws MaltChainedException;
	public boolean getKnown(Integer value);
	public boolean getKnown(String value);
	public void printSymbolTable(Logger logger) throws MaltChainedException;
	public void save(BufferedWriter out) throws MaltChainedException;
	public void load(BufferedReader in) throws MaltChainedException;
	public String getName();
	public int getValueCounter();
	public int getNullValueCode(NullValueId nullValueIdentifier) throws MaltChainedException;
	public String getNullValueSymbol(NullValueId nullValueIdentifier) throws MaltChainedException;
	public boolean isNullValue(String value) throws MaltChainedException;
	public boolean isNullValue(int code) throws MaltChainedException;
	public void copy(SymbolTable fromTable) throws MaltChainedException;
}
