package org.maltparser.ml;

import java.util.ArrayList;



public class KBestList {
	protected ArrayList<KBestItem> kBestList;
	protected int k = -1;
	protected int currentItemIndex;
	
	public KBestList() {
		this(-1);
	}
	
	public KBestList(int k) {
		setK(k);
		if (k > 0) {
			kBestList = new ArrayList<KBestItem>(k);
		} else {
			kBestList = new ArrayList<KBestItem>();
		}
	}
	
	public void clear() {
		kBestList.clear();
		setCurrentItemIndex(0);
	}
	
	public void addKBestItem(int codes) {
		KBestItem kBestItem = new KBestItem();
		kBestItem.setClassCode((int)codes);
		kBestList.add(kBestItem);
	}
	
	public void addKBestItem(int codes, double score) {
		KBestItem kBestItem = new KBestItem();
		kBestItem.setClassCode((int)codes);
		kBestItem.setScore(score);
		kBestList.add(kBestItem);
	}
	
	public KBestItem getNextClassCode() {
		if (currentItemIndex < kBestList.size()) {
			return kBestList.get(currentItemIndex++);
		} else {
			return null;
		}
	}
	
	public int getK() {
		return k;
	}

	public int getCurrentSize() {
		return kBestList.size();
	}

	protected void setK(int k) {
		this.k = k;
	}
	
	protected int getCurrentItemIndex() {
		return currentItemIndex;
	}

	protected void setCurrentItemIndex(int currentItemIndex) {
		this.currentItemIndex = currentItemIndex;
	}
}
